#include <stdio.h>
#include "global.h"
/*#include "1tr6tables.h"*/
/*#include "dss1tables.h"*/

void dlog1tr6(u_char * buf, u_char * bend, int size) {
  u_char pd, cr_l, mt;
  int cset = 0, cs_old = 0, cs_fest = 0;
  unsigned int cr;

  /* locate message type */
  pd = *buf++;
  cr_l = *buf++;
  if (cr_l)
    cr = *buf++;
  else
    cr = 0;
  mt = *buf++;

  printf("callref %d %s size %d unknown message type N%d %.2X!\n",
    cr & 0x7f, (cr & 0x80) ? "called" : "caller", size, (pd == PROTO_DIS_N0)?0:1, mt);

  /* display each information element */
  while (buf < bend) {
    /* Is it a single octet information element? */
    if (*buf & 0x80) {
      switch ((*buf >> 4) & 7) {
        case 1:	printf("  Shift %.2X\n", *buf & 0xf);
          cs_old = cset;
          cset = *buf & 7;
          cs_fest = *buf & 8;
          break;
        case 3:	printf("  Congestion level %.2X\n", *buf & 0xf);
          break;
        case 2:	if (*buf == 0xa0) {
            printf("  More data\n");
            break;
          }
          if (*buf == 0xa1) {
            printf("  Sending complete\n");
          }
          break;
          /* fall through */
        default:printf("  Reserved %.2X\n", *buf);
          break;
      }
      buf++;
      continue;
    }
    /* No, locate it in the table */
    if (cset == 0) {
      printf("  Codeset %.2X attribute %.2X attribute size %d\n", cset, *buf, buf[1]);
    } else if (cset == 6) {
      printf("  Codeset %.2X attribute %.2X attribute size %d\n", cset, *buf, buf[1]);
    } else
      printf("  Unknown Codeset %.2X attribute %.2X attribute size %d\n", cset, *buf, buf[1]);
    /* Skip to next element */
    if (cs_fest == 8) {
      cset = cs_old;
      cs_old = 0;
      cs_fest = 0;
    }
    buf += buf[1] + 2;
  }
}
