#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "global.h"

#define A_BUFLEN 768

void dlogAuerswald(u_char * buf, u_char * bend, int size) {
  buf++;
  printf(" Auerswald Protocol CRN=");
  if (*buf==0) printf("dummy	");
  else printf("%.2X	",*buf);
  buf++;
  if (*buf==0x62) printf("\nAuerSystel 1 (62)\n  ");
  else if (*buf==0x63) printf("\nAuerSystel 1 (63)\n  ");
  else if (*buf==0x63) printf("\nAuerSystel 2\n  ");
  else printf("\nunknown MT %.2X\n  ", *buf);
  buf++;
  if (*buf==0x32) printf("Auerswald-Facility		");
  else if (*buf==0x111) printf("AuerSystel 2\n    ");
  else printf("unknown IE %.2X			", *buf);
  buf++;
  bend--;
  while (buf++ < bend)
	printf("%.2X ",*buf);
  printf("\n");
}


int readline(int sock, char *buf) {
  int len=1, pos=0;

  bzero(buf, A_BUFLEN);
  while(len) {
    len=read(sock, buf+pos, 1);
    if (len==0) {
      perror("Connection terminated");
      exit(1);
    }
    if (buf[pos]==10) len=0;
    else pos++;
  }
  buf[pos]=0;
  return(pos-1);
}


void main_auerswald(char *auhost) {
  struct	sockaddr_in addr;
  struct	hostent *hostinf;
  int		sock, n, p, dir, len, hitl=18;
  char		buf[A_BUFLEN], *pos, *ifname,
		*hit="\x00\x0b[DKANPROT-Debug ",
		time[22];
  unsigned char	frame[256];

  printf("  Resolving ...\n");
  if ((hostinf=gethostbyname(auhost))==0) {
    perror("cannot resolve");
    exit(1);
  }

  if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("can't create socket");
    exit(1);
  }

  bzero((char *) &addr, sizeof(addr));
  addr.sin_family = AF_INET;
  addr.sin_addr = *((struct in_addr *) hostinf->h_addr_list[0]);
  addr.sin_port = htons(42225);

  inet_ntop(AF_INET, &addr.sin_addr, time, 20);
  printf("  Connecting to %s ...\n", time);
  if (connect(sock, (struct sockaddr *)&addr, sizeof(struct sockaddr)) == -1) {
    perror("Can't connect");
    exit(1);
  }

  printf("  Login ...\n");
  if (write(sock, "\x00\x01""DecoderV=1\n",13)<13) {
    perror("Failed to write to socket");
    exit(1);
  }

  printf("  Wait for Login ...\n");
  sleep(1);

#ifdef DEBUG
  n=readline(sock, buf);
  printf("n=%d	",n);
  p=2;
  while(p<n)
    printf( "%c", buf[p]);
  printf("\n");
#endif

  if (write(sock, "\x00\x02",2)<2) {
    perror("Failed to write to socket");
    exit(2);
  }

  while(1) {
    n=readline(sock, buf);
    p=strcmp(buf,hit);
    if (p==0)	pos=strstr(buf+hitl, "]");
    else	pos=0;
    if (pos) {
      ftime(&rt1);
      p=pos-buf+1;
      while(buf[p]==32 && p<sizeof(buf)) p++;
      if ((buf[p]=='T' || buf[p]=='N') && buf[p+3]==':') {
	if (buf[p]=='N') dir=0; else dir=1;
	ifname=buf+p+1;
	ifname[2]=0;
	p+=4;
	while(buf[p]==32 && p<sizeof(buf)) p++;

	len=0;
	while(p<n) {
	  frame[len++]=strtol(buf+p,(char **) NULL, 16);
	  p+=3;
	}

	rt2=*localtime(&rt1.time);
	sprintf(time, "%02d:%02d:%02d.%03d",
			rt2.tm_hour,rt2.tm_min, rt2.tm_sec, rt1.millitm);
	strcat(time," Port ");
	strcat(time,ifname);
	frame[0]=0x00; frame[1]=0x83; frame[2]=0x00; frame[3]=0x00;
	if (len>6) dlogframe(frame,len-2,dir,time);

      } else {
	printf("%c[;m%s\n ", 27, buf+p);
      }
      fflush(stdout);
    }
  }
}
