#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "global.h"


struct vtsl bclists[] = {
	{0x00, "Speech"},
	{0x08, "UDI"},
	{0x09, "RDI"},
	{0x10, "audio"},
	{0x11, "7k aud"},
	{0x18, "Video"},
	{  -1, ""} };

struct vtsl redirtyps[] = {
	{0x00, "unk"},
	{0x01, "CFB"},
	{0x02, "CFNr"},
	{0x04, "CD"},
	{0x09, "DTE OOO"},
	{0x0A, "by DTE"},
	{0x0F, "CFU"},
	{0xFE, "2 cgpn"},
	{  -1, ""} };


void showcall(void) {
  char sendbuf[1024], *name;
  char cgna[64]="", cdna[64]="", rena[64]="";
  int sock, filter;
  struct sockaddr_in dest;
  struct hostent host;
  struct protoent proto;
  FILE *fi;

  ftime(&rt1);
  rt2=*localtime(&rt1.time);

  if (*cdpn==0) strcpy(cdpn,"!any");
  if ((fi=fopen(phonebook,"r"))) {
    while (!feof(fi)) {
      fgets(sendbuf, 1024, fi);
      sendbuf[strlen(sendbuf)-1]=0;
      name=sendbuf;
      while (*name++>32);
      *(name-1)=0;
      while (*name++<=32);
      name--;
      if (strcmp(sendbuf,cgpn)==0)	strncpy(cgna,name,64);
      if (strcmp(sendbuf,cdpn)==0)	strncpy(cdna,name,64);
      if (strcmp(sendbuf,redi)==0)	strncpy(rena,name,64);
      }
    fclose(fi);
    cgna[63]=0;
    cdna[63]=0;
    rena[63]=0;
  }

  sock=*cgna;

  if (sock==0) {
    if (*cgpn=='+') strcpy(num,cgpn+1); else strcpy(num,cgpn);
    fi=0;
    while (strlen(num)>0 && fi==0) {
      sprintf(sendbuf, "/etc/isdn/Locations/%s",num);
      fi=fopen(sendbuf, "r");
      num[strlen(num)-1]=0;
    }
    if (fi) {
      if (*cgpn=='+') strcpy(num,cgpn+1); else strcpy(num,cgpn);
      while (!feof(fi)) {
	fgets(sendbuf, 1024, fi);
	sendbuf[strlen(sendbuf)-1]=0;
	name=sendbuf;
	while (*name++>32);
	*(name-1)=0;
	while (*name++<=32);
	name--;
	if (*cgpn) if (strcmp(sendbuf,num)==0) strncpy(cgna,name,64);
      }
      fclose(fi);
    }
  }

  if (sock==0 && autoadd && *cgpn!='<') {
    if ((fi=fopen(phonebook,"a"))) {
      if (cgsatyp==9) {
	fprintf(fi, "%s\t\"%s\"\n", cgpn, cgsa);
      } else {
	fprintf(fi, "%s\t%s", cgpn, cgpn);
	if (*cgsa) fprintf(fi, ".%s", cgsa);
	fprintf(fi, " (%.2d.%.2d.%d, %.2d:%.2d)\n", rt2.tm_mday,
			1+rt2.tm_mon, 1900+rt2.tm_year, rt2.tm_hour, rt2.tm_min);
      }
      fclose(fi);
    } else
      fprintf(stderr, "Unable to open phone book for writing (%s)\n", strerror(errno));
  }

  if (broadcast) {
    proto=*getprotobyname("udp");
    if ((sock=socket(PF_INET, SOCK_DGRAM, proto.p_proto))<0)
      fprintf(stderr, "Unable to create socket (%s)\n", strerror(errno));
    else {
      gethostname(sendbuf, 1024);
      host=*gethostbyname(sendbuf);
      errno=0;
      dest.sin_family=AF_INET;
      dest.sin_addr.s_addr=bcaddr;
      dest.sin_port=*host.h_addr_list[0];
      bind(sock, (struct sockaddr *) &dest, sizeof(dest));
      if (errno!=0) perror("sendto (bind)");

      errno=0;
      *sendbuf=-1;
      setsockopt(sock, SOL_SOCKET, SO_BROADCAST, sendbuf, sizeof(int));
      if (errno!=0) perror("sendto (setsockopt)");

      name=sendbuf;
		  name+=sprintf(name, "%c%c%.2d:%.2d:%.2d", 0x06, 8,
					rt2.tm_hour, rt2.tm_min, rt2.tm_sec);
		  name+=sprintf(name, "%c%c%c"  , 0x08, 1, _BC);
		  name+=sprintf(name, "%c%c%s"  , 0x20, strlen(cgpn), cgpn);
      if (*cgna)  name+=sprintf(name, "%c%c%s"  , 0x22, strlen(cgna), cgna);
      if (*cgsa)  name+=sprintf(name, "%c%c%c%s", 0x28, strlen(cgsa)+1, cgsatyp, cgsa);
		  name+=sprintf(name, "%c%c%s"  , 0x40, strlen(cdpn), cdpn);
      if (*cdna)  name+=sprintf(name, "%c%c%s"  , 0x42, strlen(cdna), cdna);
      if (*cdsa)  name+=sprintf(name, "%c%c%s"  , 0x48, strlen(cdsa), cdsa);
      if (*redi)  name+=sprintf(name, "%c%c%s"  , 0x30, strlen(redi), redi);
      if (*rena)  name+=sprintf(name, "%c%c%s"  , 0x32, strlen(rena), rena);
      name+=sprintf(name, "%c%c", 0, 0);
      dest.sin_family=AF_INET;
      dest.sin_addr.s_addr=bcaddr;
      dest.sin_port=htons(broadcast);

      errno=0;
      sendto(sock, sendbuf, name-sendbuf, 0, (struct sockaddr *) &dest, sizeof(dest));
      close(sock);
      if (errno!=0) perror("sendto (sendto)");
    }
  }

  filter=NoData && (_BC==8 || _BC==9);
  if (*logfile && !filter) {
    if ((fi=fopen(logfile,"a"))) {
		 fprintf(fi, "\n%.2d:%.2d\tfrom:\t%s", rt2.tm_hour, rt2.tm_min, cgpn);
      if (*cgsa) fprintf(fi, ".%s", cgsa);
      if (*cgna) fprintf(fi, "\t%s", cgna);
		 fprintf(fi, "\n%s\tto:\t%s", find(bclists, _BC), cdpn);
      if (*cdsa) fprintf(fi, ".%s", cdsa);
      if (*cdna) fprintf(fi, "\t%s", cdna);
      if (*redi) fprintf(fi, "\n%s\tvia:\t%s", find(redirtyps, redr), redi);
      if (*rena) fprintf(fi, "\t%s", rena);
		 fprintf(fi, "\n\n");
      fclose(fi);
    } else
    fprintf(stderr, "Trouble opening logfile (%s)\n", strerror(errno));
  }
}


void readbc(char * arg) {
  int ok=1, t, c;
  char chk[32];
  for(c=1;c<5;c++) {
    t=atoi(arg);
    if (t<0 || t>255) ok=0;
    if (ok) {
      sprintf(chk, "%d", t);
      if (strncmp(arg,chk,strlen(chk))) ok=0;
      bcaddr=bcaddr<<8 | t;
    }
    if (ok) arg+=strlen(chk);
    if (c==4) {
      if (*arg!=':') ok=0; else arg++;
    } else {
      if (*arg!='.') ok=0; else arg++;
    }
  }

  bcaddr=htonl(bcaddr);
  t=atoi(arg);
  sprintf(chk, "%d", t);
  if (strncmp(arg,chk,strlen(chk))) ok=0;
  if (ok) arg+=strlen(chk);
  if (*arg!=0) ok=0;
  if (ok) broadcast=t;
  else fprintf(stderr, "unable to parse 'sendto' address\n");
}
