#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dss1tables.h"
#include "dss1fac.c"

void prsignal(u_char * p) {
  p += 2;
  printf("    Signal			%s\n", find(signal, *p&0x7f));
}


void prnumber(u_char * p, char f_reason, char f_empty) {
  int l,t,t2=0;
  *num=0;

  p++;
  l = *p++ - 1;
  t=*p;
  if (!(t & 0x80)) t2=(*++p)&0x63;
////////////////////////////////////////
printf("%d\r",t2>>5);
////////////////////////////////////////
  if ((t2>>5)==0 || ((t>>4)&7)>0)
    printf("%sType of number		%s\n", indent, numtyp[(t>>4)&7]);
  if ((t2>>5)==0 || (t&15)>0)
    printf("%sNumbering plan		%s\n", indent, find(numplan, t&15));
  if (!(t & 0x80)) {
    printf("%sPresentation indicator	%s\n", indent, pilist[t2>>5]);
    if ((t2>>5)==0) printf("%sScreening indicator		%s\n", indent, silist[si=t2&3]);
      else si=-1;
    l--;
    if ((t2>>5)==1) strcpy(num,"!pr");
    if ((t2>>5)==2) strcpy(num,"!na");
  };
  if (!(*p & 0x80)) {
    if (f_reason==0) printf("\x1b[41;37m\x1b[K!!%sOctet 3b (Reason for redirection) not allowed here !!%.8s\n", indent+2, colour);
    t2=(*++p)&0x7f;
    printf("%sForwarding reason		%s\n", indent, find(redirtyp, t2&15));
    l--;
  };
  p++;
  if (l<0) l=0;
  if (l) {
    *num=0;
    switch(t>>4&7) {
      case 1:strcpy(num,P_INT);break;
      case 2:strcpy(num,P_NAT);break;
      case 4:strcpy(num,P_SUB);break;
    }
    t=-1;
    while (num[++t]);
    t2=t;
    while (l--)
      num[t++]=*p++;
    num[t]=0;
    printf("%sNumber			\"%s\"\n",indent,num+t2);
  } else {
    if (f_empty==0) printf("\x1b[41;37m\x1b[K!!%sOctet(s) 4 missing (Maybe this IE should not exist?) !!%.8s\n", indent+2, colour);
  }

}


void prcause(u_char * p) {
  u_char *end;
  int t;

  end = p + p[1] + 1;
  p += 2;
  t=*p&0x7f;
  printf("    Coding			%s\n",coding[t>>5]);
  printf("    Location			%s\n",causloc[t&15]);

  if (!(*p++ & 0x80)) {
    printf("    Recommendation		%s\n", find(causrec, *p++ & 0x7F));
  }

  cause = *p++ & 0x7F;
  printf("    Cause		%.2X	%s\n", cause, find(cvlist, cause));

  if (p<end) {
    printf("    Diagnostics			");
    switch (cause) {
      /* Condition */
      case 0x01:
      case 0x03:
      case 0x10:
      case 0x31:
        printf("Condition\n");
        break;

      /* Transit network identity */
      case 0x02:
        printf("Transit network identity\n");
        break;

      /* CCBS Indicatior */
      case 0x11:
        printf("CCBS indicatior\n");
        break;

      /* Call rejected condition */
      case 0x15:
        printf("Call rejected condition\n");
        t=*p++ & 0x7F;
        printf("      Rejection reason		%s\n", find(rejrea, (t>>2)));
        printf("      Condition			%s\n", condition[t&3]);
        if ((t>>2)==0) {
	  printf("      User specific diagnostics	");
	  while (p<=end)
	    printf("%.2X ", *p++);
	  printf("\n");
        }
        if (((t>>2)==1) || ((t>>2)==2))
	  printf("      Information element id.	%.2X\n", *p);
        break;

      /* New destination */
      case 0x16:
        printf("New destination\n");
        sprintf(indent,"      ");
        prnumber(p,0,0);
        p+=p[1]+1;
        break;

      /* Discarded IE ident. */
      case 0x2B:
        printf("Discarded information element identifier\n");
        break;

      /* Attribute identity */
      case 0x39:
      case 0x3A:
      case 0x41:
        printf("Attribute identity\n");
        while (p<=end) {
	  printf("      Attribute number		%s\n", find(attrnum, *p & 0x7f));
	  if (!(*p++ &0x80)) {
	    printf("	Rejected attribute	%.2X\n", *p & 0x7F);
	    if (!(*p++ &0x80)) {
	      printf("	Available attribute	%.2X\n", *p & 0x7F);
	      p++;
	    }
	  }
        }
        break;

      /* Channel type */
      case 0x42:
        printf("Channel type\n");
        /* *p & 15 -> Q.931 Table 4-15, octet 3.2 */
        break;

      /* Channel identity */
      case 0x52:
        printf("Channel identity\n");
        break;

      /* Clearing cause */
      case 0x56:
        printf("Clearing cause\n");
        break;

      /* Incompatible parameter */
      case 0x58:
        printf("Incompatible parameter\n");
        printf("      Information element id.	%.2X\n", *p);
        break;

      /* IE ident. */
      case 0x60:
      case 0x63:
      case 0x64:
        printf("Information element identifier\n");
        break;

      /* Message Type */
      case 0x61:
      case 0x62:
      case 0x65:
        printf("Message type\n");
        break;

      /* Timer number */
      case 0x66:
        printf("Timer number\n");
        printf("      Timer number		T");
        while (p<=end)
	  printf("%c",*p++ & 0x7f);
        printf("\n");
        break;

      /* Parameter name */
      case 0x67:
        printf("parameter name\n");
        break;

      /* Facility identification */
      case 0x1D:
      case 0x32:
      case 0x45:
        printf("Facility identification\n");
        break;

    }
  }
  if (p<end) {
    printf("    Unrecognised diag. info. e.	");
    while(p<end)
      printf("%.2X ",*++p);
    printf("\n");
  }
}


void prchannel(u_char * p) {
  long int ch=0,n=0;
  int l;
  char t;

  p++;
  l = *p++;
  t=*p&0x7F;

  printf("    Interface type		");
  if (t&0x20)	printf("Other (PRI)");
  else		printf("BRI");
  if (t&0x40) {
    n=(*++p)&0x7F;
    while((*p&0x80)==0)
      n=n<<7|((*++p)&0x7F);
    printf("\n    Interface number		%ld",n);
  }
  printf("\n    Allocation priority		");
  if (t&0x08)	printf("Exclusive");
  else		printf("Preferred");
  printf("\n    Channel			");
  if (t&0x04)	printf("D-channel");
  else {
    if ((t&0x03)==0x00) printf("No channel");
    if ((t&0x23)==0x01) printf("B1-channel");
    if ((t&0x23)==0x02) printf("B2-channel");
    if ((t&0x23)==0x22) printf("??? (2)");
    if ((t&0x03)==0x03) printf("Any B-channel");
    if ((t&0x23)==0x03) printf(" (both B-channels)");
  }
  printf("\n");
  if ((t&0x23)==0x21) {
    p++;
    printf("      Coding			%s\n",coding[(*p>>5)&3]);
    printf("      Channel type		");
    switch (*p & 0x0F) {
      case 3 :printf("B-channel(s)");	break;
      case 6 :printf("H0-channel(s)");	break;
      case 8 :printf("H11-channel(s)");	break;
      case 9 :printf("H12-channel(s)");	break;
      default:printf("??? (%.2X)",*p&15);
    }
    printf("\n      Channel(s)		");
    if (*p & 0x10) {
      p++;
      l-=2;
      while (l--) {
	ch=(ch<<8)|*p++;
      }
      for(t=0; t<31; t++) {
	if (ch&(1<<t)) printf( "%d",t);
      }
    } else {
      printf("%d",*++p & 0x7F);
      while((*p&0x80)==0) {
        printf(" %d",*++p & 0x7F);
      }
    }
    printf("\n");
  }
}


void prsub(u_char * p) {
  int l,t=0;
  *num=0;

  p++;
  l = *p++ - 2;
  printf("    Type of subaddress		");
  if ((*p & 0x70) == 0)		printf("NSAP (X.214 / ISO 8348 AD2)\n");
  else {
    if ((*p & 0x70) == 0x20) printf("User specified\n");
    else
      printf("??? (%d)\n",*p >>4);}
  printf("				%s number of address digits\n",((*p & 0x08)==0)?"Even":"Odd");

  printf("    Subaddress			");
  p++;
  cgsatyp=*p++ & 0x7F;
  printf("%.2X ",cgsatyp);

  while (l--)
    num[t++]=*p++;
  num[t]=0;
  printf("\"%s\"\n",num);
}


void prbearer(u_char * p) {
  char ch;
  int l,t;

  p++;
  l=(*p++)-2;
  t=(*p++)&0x7f;
  printf("    Coding			%s\n",coding[t>>5]);
  _BC=t&31;
  printf("    Info. transfer capability	%s\n",find(bclist, _BC));

  t=(*p)&0x7f;
  printf("    Transfer mode/rate		%s, ",trmode[t>>5]);
  t=t&31;

  if (t==0x18)	printf("%d kbps",(*p++)*64);
  else		printf("%s\n", find(trrate, t));

  p++;
  /* check for user information layer 1 */
  if (((*p & 0x60) == 0x20) && (l>0)) {
    ch = ' ';
    do {
      switch (ch) {
	case ' ':
	  printf("    Layer 1 protocol		%s\n", find(LLC5, *p&0x1f));
	  break;
	case 'a':
	  printf("    User rate			%s", find(LLC5a, *p&0x1f));
	  printf(", %synchonous\n", (*p&0x40)==0?"S":"As");
	  printf("    In-band negotiation		");
	  printf("%sossible\n", (*p&0x20)==0?"Not p":"P");
	  break;
	case 'b':
	  if (1) {	/* V.110 */
	    printf("    Intermediate rate		");
	    switch (*p & 0x60) {
	      case 0x00:printf("??? (00)\n");  break;
	      case 0x20:printf("8 kbit/s\n");  break;
	      case 0x40:printf("16 kbit/s\n"); break;
	      case 0x60:printf("32 kbit/s\n"); break;
	    }
	    printf("    Network independant clock	");
	    printf("Tx: %srequired, ",	 (*p&0x10)==0?"not ":"");
	    printf("Rx: can%s accept\n", (*p&0x08)==0?"not":"");
	    printf("    Flow control		");
	    printf("Tx: %srequired, ",	 (*p&0x04)==0?"not ":"");
	    printf("Rx: can%s accept\n", (*p&0x02)==0?"not":"");
	  } else {	/* V.120 */
	    printf("    Rate adaption header	");
	    printf("%sincluded\n",	 (*p&0x40)==0?"not ":"");
	    printf("    Multiple Frame establishment	");
	    printf("%ssupported\n",	  (*p&0x20)==0?"not ":"");
	    printf("    Mode of operation		");
	    printf("%s\n",	 (*p&0x10)==0?"Bit transparent":"Protocol sensitive");
	    printf("    Logical link identifier	");
	    printf("%s\n",	 (*p&0x08)==0?"Default, LLI 256 only":"Full protocol negotiation");
	    printf("    Message originator is	");
	    printf("%s\n",	 (*p&0x04)==0?"Default assignee":"Assignor only");
	    printf("    Negotioation is done	");
	    printf("%s\n",	 (*p&0x04)==0
	    ?"with USER INFORMATION messages on a temporary signalling connection"
	    :"in-band using logical link zero");
	  }
	  break;
	case 'c':
	  printf("    Data format			%s/%s/%s\n",
		dformatb[(*p&0x18)>>3], dformatp[*p&0x03], dformats[(*p&0x60)>>5]);
	  break;
	case 'd':
	  printf("    Modem type			V.%s", find(LLC5d, *p&0x3f));
	  printf(", %sduplex\n",(*p&0x40)==0?"half":"full");
	  break;
	default:
	  printf("    octet 5%c	???		%.2X\n", ch,*p);
      }
      if (ch == ' ')	ch = 'a';
      else		ch++;
      l--;
    }
    while (!(*p++ & 0x80));
  }
  /* check for user information layer 2 */
  if (((*p & 0x60) == 0x40) && (l>0)) {
    printf("    Layer 2 protocol		");
    if ((*p & 0x1f) == 2)	printf("Q.931/I.451\n");
    else if ((*p & 0x1f) == 6)	printf("X.25, packet layer\n");
    else if ((*p & 0x1f) == 12)	printf("LAN logical link control (ISO/IEC 8802-1)\n");
    else			printf("%.2X\n",*p++ & 0x1f);
    l--;
    p++;
  }
  /* check for user information layer 3 */
  if (((*p & 0x60) == 0x60) && (l>0)) {
    printf("    Layer 2 protocol		");
    if ((*p & 0x1f) == 2)	printf("Q.931/I.451\n");
    else if ((*p & 0x1f) == 6)	printf("X.25, packet layer\n");
    else if ((*p & 0x1f) == 11)	printf("ISO/IEC TR 9577\n");
    else			printf("%.2X\n",*p++ & 0x1f);
    l--;
    p++;
    if (l>1) {
      if (((*p & 0x1E) == 0x18) && (*(p+1) & 0x1E) == 0x18)
        printf("				IP (RFC 791)(ISO/IEC TR 9577)\n");
      if (((*p & 0x1E) == 0x18) && (*(p+1) & 0x1E) == 0x18)
        printf("				PPP (RFC 1548)\n");
    }
  }
}


void prhlc(u_char * p) {
  p+=2;
  printf("    Coding			%s\n",coding[(*p>>5)&3]);
  printf("    Interpretation		");
  if (((*p>>2)&7)==4)	printf("First HLC to be used\n");
  else			printf("??? (%.2X)\n",(*p>>2)&7);
  printf("    Presentation		");
  if ((*p&3)==1)	printf("High layer profile\n");
  else			printf("??? (%.2X)\n",*p&3);
  p++;
  printf("    HLCI			%s\n", find(HLCI, *p&0x7F));
  if (!(*p++&0x80))
    printf("    Extended HLCI		%s\n", find(HLCI, *p&0x7F));
}


void general(u_char * p) {
  int l, octet = 3;

  p++;
  l = *p++-1;

  /* Iterate over all octets in the information element */

  if (l>=0) {
    printf("    octet %d			%.2X ", octet, *p++);
    while (l--) {

      /* last octet in group? */
      if (*p & 0x80) {
        octet++;
        printf(" \n    octet %d			%.2X ", octet, *p++);
      } else
        printf("%.2X ", *p++);
    }
    printf("\n");
  } else
    printf("    octet %d			(empty)\n", octet);
}


void prinforeq(u_char * p) {
  p+=2;
  printf("    Request indicator		%s\n",(*p&0x40)==0?
    "Information request completed":"Prompt for additional information");
  printf("    Type of information		");
  switch ((*p) & 0x3F) {
    case 0	:printf("undefined\n");		break;
    case 1	:printf("authorization code\n");	break;
    case 2	:printf("address digigts\n");		break;
    case 3	:printf("terminal identification\n");	break;
    default	:printf("??? (%.2X)\n",(*p) & 0x3F);
  }
}


void prfeatact(u_char * p) {
  int l, t;

  p++;
  printf("    Feature identifier		");
  l = *p++;
  t = *p++;
  if (l==2) {
    t = (t<<7) | ((*p++) & 0x7F);
    printf("%.4X",t);
  } else
    printf("%.2X",t);
}


void prfeatind(u_char * p) {
  int l, t;

  p++;
  printf("    Feature identifier		");
  l = *p++;
  t = *p++;
  if (l==3) {
    t = (t<<7) | ((*p++) & 0x7F);
    printf("%.4X",t);
  } else
    printf("%.2X",t);
  printf("    Status				%s\n", find(FeatStat, (*p++) & 0x0F));
}


void prdisplay(u_char * p) {
  int l;

  p++;
  l = *p++;
  printf("    Message			\"");
  while (l--) printf("%c",*p++);
  printf("\"\n");
}


void prkeypad(u_char * p) {
  int l;

  p++;
  l = *p++;
  printf("    Keypad information		\"");
  while (l--) printf("%c",*p++);
  printf("\"\n");
}


void prspid(u_char * p) {
  int l;

  p++;
  l = *p++;
  printf("    SPID			\"");
  while (l--) printf("%c",*p++);
  printf("\"\n");
}


void prnotify(u_char * p) {
  int l, t;

  p++;
  l=(*p++)-2;
  t=(*p)&0x7f;
  while ((*p&0x80)==0)
    t= (t<<7)|(*p++&0x7f);

  printf("    Notify			%s\n", find(notify, t));
  if (t==3) {
    printf("    ASN.1 component		");
    while (l--)
      printf("%.2X ",*p++);
    printf("\n");
  }
}


void prstate(u_char * p) {
  p += 2;
  printf("    Coding			%s\n", coding[(*p&0xc0)>>6]);
  printf("    Call state			%s\n", find(CState, *p&0x3f));
}


void prprogr(u_char * p) {
  int l, t;

  p++;
  l=*p++;
  t=(*p++)&0x7f;
  printf("    Coding			%s\n",coding[t>>5]);
  printf("    Location			%s\n",causloc[t&15]);
  l--;
  while (l--) {
    printf("    Progress description	%s\n", find(pdesc, (*p++)&0x7f));
  }
}


void prdate(u_char * p) {
  int l, y,m,d,H;

  p++;
  l = *p++;
  printf("    Date/Time			");
  if ((l==5) || (l==6)) {
    y=*p++;
    m=*p++;
    d=*p++;
    H=*p++;
    printf("20%.2d-%.2d-%.2d  %.2d:%.2d",y,m,d,H,*p++);
    if (l==6) printf(":%.2d",*p++);
  } else {
    while (l--) {
      printf("%.2d",*p++);
      if (l) printf("."); else printf("\n");
    }
  }
  printf("\n");
}


void prrestart(u_char * p) {
  p++;
  p++;
  printf("    Restart			%s\n",find(Restart,*p & 0x7F));
}


void chkcgpn(void) {
  /* if we receive two calling party numbers in a setup, report
     the network provided one as redirection number */
  if (*cgpn==0) {
    strcpy(cgpn,num);
    cgsi=si;
  } else {
    if (cgsi==3 && si==0) {		/* had 'network provided', got additional 'unscreened' */
      strcpy(redi,cgpn);
      strcpy(cgpn,num);
      redr=0xFE;
    } else if (cgsi==0 && si==3) {	/* had 'unscreened', got additional 'network provided' */
      strcpy(redi,num);
      redr=0xFE;
    }
/*    printf("\x1b[41;37m\x1b[K!! Converted duplicate calling party number to redirection number%s\n", colour); */
  }
}


u_char dlogdss1(u_char * buf, u_char * bend, int size) {
  u_char pd=0, cr_l, mt;
  u_char f;
  int i;
  unsigned int cr;

  /* locate message type */
  buf++;
  cr_l = *buf++ & 0x0F;

  cr = 0;
  if (cr_l)	{ pd = *buf;
      cr = *buf++ & 0x7f;}
  if (cr_l > 1)	cr = (cr<<8)|*buf++;

  mt = *buf++;
  for (i = 0; i < MTSIZE; i++)
    if (mtlist[i].nr == mt) break;

  if (cr)
    printf(" Callref %d%s\n", cr, (pd & 0x80) ? "t" : "o");
  else
    printf(" GLOBAL\n");

  /* display message type if it exists */
  if (i == MTSIZE)
    printf("%sunknown message type %.2x size %d\n", colour, mt, size);
  else
    printf("%s%s\n", colour, mtlist[i].descr);


  /* display each information element */
  while (buf < bend) {
    /* Is it a single octet information element? */
    printf("%s", colour);
    if (*buf & 0x80) {
      switch ((*buf >> 4) & 7) {
        case 1:
          printf("  Shift\n    ");
          if (*buf & 8) printf("Non-");
          printf("Locking\n    Codeset			%.2x\n", *buf & 0x7);
          break;
        case 2:
          if (*buf == 0xA0) {
            printf("  More data\n");
          } else
          if (*buf == 0xA1) {
            printf("  Sending complete\n");
          } else
          printf("  ??? (%.2x)\n", *buf);
          break;
        case 3:
          printf("  Congestion level\n");
          printf("  Congestion level		");
          switch (*buf & 15) {
            case  0:printf("receiver ready\n");
            case 15:printf("receiver not ready\n");
            default:printf("??? (%.2X)\n",*buf & 15);
          }
          break;
        case 5:
          printf("  Repeat indicator %.2x\n", *buf & 15);
          break;
        default:
          printf("  Reserved (%.2x)\n", *buf);
          break;
      }
      buf++;
      continue;
    }
    printf("  ");
    sprintf(indent,"    ");
    switch (*buf) {
      case 0x00: printf("Segmented message\n");			general(buf);		break;
      case 0x01: printf("Change status\n");			general(buf);		break;
      case 0x04: printf("Bearer capability\n");			prbearer(buf);		break;
      case 0x08: printf("Cause\n");				prcause(buf);		break;
      case 0x0C: printf("Connected address\n");			general(buf);		break;
      case 0x0D: printf("Extended facility\n");			prEfacility(buf);	break;

      case 0x10: printf("Call identity\n");			general(buf);		break;
      case 0x14: printf("Call state\n");			prstate(buf);		break;
      case 0x18: printf("Channel identification\n");		prchannel(buf);		break;
      case 0x19: printf("Data link connection identifier\n");	general(buf);		break;
      case 0x1C: printf("Facility\n");				prSfacility(buf);	break;
      case 0x1E: printf("Progress indicator\n");		prprogr(buf);		break;

      case 0x20: printf("Network-specific facilities\n");	general(buf);		break;
      case 0x24: printf("Terminal capabilities\n");		general(buf);		break;
      case 0x27: printf("Notification indicator\n");		prnotify(buf);		break;
      case 0x28: printf("Display\n");				prdisplay(buf);		break;
      case 0x29: printf("Date/Time\n");				prdate(buf);		break;
      case 0x2C: printf("Keypad facility\n");			prkeypad(buf);		break;

      case 0x30: printf("Keypad echo\n");			general(buf);		break;
      case 0x32: printf("Information request\n");		prinforeq(buf);		break;
      case 0x34: printf("Signal\n");				prsignal(buf);		break;
      case 0x35: printf("Swichhook\n");				general(buf);		break;
      case 0x38: printf("Feature activation\n");		prfeatact(buf);		break;
      case 0x39: printf("Feature indication\n");		prfeatind(buf);		break;
      case 0x3A: printf("Service profile identification\n");	prspid(buf);		break;
      case 0x3B: printf("Endpoint identifier\n");		general(buf);		break;	/* Q.932 33 */

      case 0x40: printf("Information rate\n");			general(buf);		break;
      case 0x41: printf("Precedence level\n");			general(buf);		break;
      case 0x42: printf("End-to-end transit delay\n");		general(buf);		break;
      case 0x43: printf("Transit delay selection/indication\n");general(buf);		break;
      case 0x44: printf("Packet layer binary parameters\n");	general(buf);		break;
      case 0x45: printf("Packet layer window size\n");		general(buf);		break;
      case 0x46: printf("Packet size\n");			general(buf);		break;
      case 0x47: printf("Closed user group\n");			general(buf);		break;
      case 0x48: printf("Link layer core parameters\n");	general(buf);		break;
      case 0x49: printf("Link layer protocol parameters\n");	general(buf);		break;
      case 0x4A: printf("Reverse charge indication\n");		general(buf);		break;
      case 0x4C: printf("Connected number\n");			prnumber(buf,0,1);	break;
      case 0x4D: printf("Connected subaddress\n");		prsub(buf);		break;

      case 0x50: printf("X.213 priority\n");			general(buf);		break;
      case 0x51: printf("Report type\n");			general(buf);		break;
      case 0x53: printf("Link integrety verification\n");	general(buf);		break;
      case 0x57: printf("PVC status\n");			general(buf);		break;

      case 0x6C: printf("Calling party number\n");		prnumber(buf,0,1);	chkcgpn();		break;
      case 0x6D: printf("Calling party subaddress\n");		prsub(buf);		strcpy(cgsa,num);	break;

      case 0x70: printf("Called party number\n");		prnumber(buf,0,0);	strcpy(cdpn,num);	break;
      case 0x71: printf("Called party subaddress\n");		prsub(buf);		strcpy(cdsa,num);	break;
      case 0x73: printf("Original called number\n");		prnumber(buf,0,0);	break;
      case 0x74: printf("Redirecting number\n");		prnumber(buf,1,1);	strcpy(redi,num);	break;
      case 0x76: printf("Redirection number\n");		prnumber(buf,1,1);	break;
      case 0x78: printf("Transit network selection\n");		general(buf);		break;
      case 0x79: printf("Restart indicator\n");			prrestart(buf);		break;
      case 0x7C: printf("Low layer compatibility\n");		prbearer(buf);		break;
      case 0x7D: printf("High layer compatibility\n");		prhlc(buf);		break;
      case 0x7E: printf("User-user information\n");		general(buf);		break;
      case 0x7F: printf("Escape for extension\n");		general(buf);		break;

      default  : printf("attribute %.2x attribute size %d\n", *buf, buf[1]);
    }
    /* Skip to next element */
    buf+=buf[1]+2;
  }

  if (*execonconn || *execondisc) {
#ifdef DEBUG
fprintf(stderr,"tracI: cr=%d, mt=%.2X, cause=%.2X\n",cr,mt,cause);
#endif
    /*	07=Conn		0F=ConnAck	*/
    if ((mt==0x07 || mt==0x0F) && *execonconn) {
      f=-1;
      for(i=0;i<MaxCR;i++) {
#ifdef DEBUG
fprintf(stderr,"set CallRef[%d]=%d\t",i,CallRef[i]);
#endif
        if (CallRef[i]==0) f=i;
        if (CallRef[i]==cr) {
          f=-2;
          i=MaxCR;
fprintf(stderr,"\ntracI: Duplicate cr(%d)?!?\n",cr);
        }
      }
#ifdef DEBUG
fprintf(stderr,"\nsetCR (%d)\n",f);
#endif
      if (f>=0) CallRef[f]=cr;

      if (f>-2) {
        numconnects++;
        if (numconnects==1) {
#ifdef DEBUG
fprintf(stderr,"EXECONCONN\n");
#endif
          if (system(execonconn)<=0) {
            fprintf(stderr,"Unable to start EXECONCONN - disbling\n");
            *execonconn=0;
          }
        }
      }
    }
    /*	4D=Rel	5A=RelComp	45=Disc	*/
    if ((mt==0x45 || mt==0x4D || mt==0x5A) && cause!=0x1A && *execondisc && numconnects) {
      f=-1;
      for(i=0;i<MaxCR;i++) {
#ifdef DEBUG
fprintf(stderr,"clr CallRef[%d]=%d\t",i,CallRef[i]);
#endif
        if (CallRef[i]==cr) f=i;
      }
#ifdef DEBUG
fprintf(stderr,"\nclrCR (%d)\n",f);
#endif
      if (f>=0) {
        CallRef[f]=0;
        numconnects--;
        if (numconnects==0) {
#ifdef DEBUG
fprintf(stderr,"EXECONDISC\n");
#endif
          if (system(execondisc)<=0) {
            fprintf(stderr,"Unable to start EXECONDISC - disbling\n");
            *execondisc=0;
          }
        }
      }
    }
#ifdef DEBUG
fprintf(stderr,"numconnects=%d\n",numconnects);
#endif
  }

  return(mt);
}
