#include <stdio.h>
#include <string.h>
#include "global.h"
#include "globaltables.h"

#ifdef P_DSS1
#include "dss1.h"
#endif

#ifdef P_1TR6
#include "1tr6.h"
#endif

#ifdef P_ACKERMANN
#include "ackermann.h"
#endif

#ifdef P_AUERSWALD
#include "auerswald.h"
#endif

#ifdef U_CTI
#include "cti.h"
#endif


char	cgpn[40]="", cdpn[40]="", cgsa[40]="", cdsa[40]="", redi[40]="",
	P_INT[8]="00", P_NAT[8]="0", P_SUB[16]="", cgsatyp,
	logfile[1024]="",
	phonebook[1024]="/etc/isdn/phonebook",
	readfn[1024]="/dev/isdnctrl",
	execonconn[1024]="",
	execondisc[1024]="",
	logprefix[64]="",
	numconnects=0;
u_char	cause, si=-1, cgsi=-1, redr=-1;
int	_L2=1, _Unk=1, broadcast=0, bcaddr=0, autoadd=0,
	_BC, NoData=0, NoData, CallRef[MaxCR];

char * find(struct vtsl * list, int e) {
  int i;

  for(i=0; list[i].nr!=-1; i++)
    if (list[i].nr==e) break;

  if (list[i].nr==-1) {
    sprintf(uk, "??? (%.2X)", e);
    return(uk);
  } else
    return(list[i].descr);
}


void dlogsapi0 (u_char *buf, int size, int dir) {
  u_char *bend, res, ftyp;
  char	fttmp[16];

  ftyp = buf[2];

  if (_L2) {
    printf("%s", logprefix);
    if (ftyp&1) {
      printf(" %s", find(usftyp, ftyp));
      if ((ftyp & 2)==0) printf(" p/f=%d", buf[2]>>4&1);
    } else printf(" p/f=%d seqs=%d seqr=%d", buf[3]&1, buf[2]>>1, buf[3]>>1);
  } else if ((ftyp&3)!=1) {
    printf("%s", logprefix);
    if (ftyp&1) {
      strncpy(fttmp, find(usftyp, ftyp), sizeof(fttmp));
      res=0;
      while (fttmp[++res]>32);
      fttmp[res]=0;
      printf(" %s", fttmp);
    }
  }


  if ( ((ftyp&1)==0) | (ftyp==0x03) | (ftyp==0x13) ) {
    if ((ftyp & 3)==3) {
      buf += 3;
      size -= 3;
    } else {
      buf += 4;
      size -= 4;
    }
    bend = buf+size;
    res=0;

#ifdef P_1TR6
    if ((0xfe & buf[0]) == PROTO_DIS_N0)	dlog1tr6(buf, bend, size);
    else
#endif
#ifdef P_DSS1
    if (buf[0] == 8)			res=	dlogdss1(buf, bend, size);
    else
#endif
#ifdef P_ACKERMANN
    if (buf[0] == 0xaa)				dlogAckermann(buf, bend, size);
    else
#endif
#ifdef P_AUERSWALD
    if (buf[0] == 0x0d)				dlogAuerswald(buf, bend, size);
    else
#endif
    if (buf[0] == 0x44 || buf[0] ==0x47)	printf("%sAscom status %.2x\n", logprefix, buf[0]);
    else
    printf("\n%s\nUnknown protocol %.2x!\n", logprefix, buf[0]);
#ifdef U_CTI
    if (res==5 && dir) showcall();
#endif
  } else if (((ftyp&3)!=1) | _L2) printf("\n");
}

void dlogsapi63(u_char *buf, int size, int dir) {
  if (buf[3]==15) {
      printf("%s TEI management ", logprefix);
      printf("\n  %s\t\tRN=%.2X%.2X, AI=%d\n", find(teiaction, buf[6]), buf[4], buf[5], buf[7]>>1);
  } else {
    printf("%s unknown management frame MEI=0x%.2X\n", logprefix, buf[3]);
  }
}

void dlogframe(u_char *buf, int size, int dir, char *time) {
  u_char sapi, tei, ftyp;
  char	temp[8];

  *cgpn=*cdpn=*cgsa=*cdsa=*redi=0;
  cgsi=-1;
  cgsatyp=-1;
  redr=0;

  sapi = buf[0] >> 2;
  tei  = buf[1] >> 1;
  ftyp = buf[2];

  if (dir) colour="\x1b[;32;1m";
      else colour="\x1b[;33;1m";
  snprintf(logprefix, sizeof(logprefix), "%s%c%s ", colour, dir?'>':'<' , time);
  if (_L2) {
    strcat(logprefix, frmtyp[ftyp & 3]);
    strcat(logprefix, " ");
  }
  if (tei==127) {
    strcat(logprefix, "broadcast");
  } else {
    sprintf(temp, "TEI %d", tei);
    strcat(logprefix, temp);
  }

  switch(sapi) {
    case  0:dlogsapi0(buf, size, dir);break;
    case 63:dlogsapi63(buf, size, dir);break;
    case  1:/* packet mode */
    case 16:/* X.25 level3 */
    default:
      if (tei == GROUP_TEI) {
        printf("%s unknown sapi %d, broadcast\n", logprefix, sapi);
      } else {
        printf("%s unknown sapi %d, tei %d\n", logprefix, sapi, tei);
      }
  }

}
